/*
 *	Copyright © 2015 Matthieu DUVAL, Rudy DUCHE
 *
 *	This file is part of RizzleHash.
 *
 *	RizzleHash is free software: you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation, either version 3 of the License, or
 *	(at your option) any later version.
 *
 *	RizzleHash is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with RizzleHash.  If not, see <http://www.gnu.org/licenses/>
 */
#include "../include/RH_Encryption.h"

RH_Encryption::RH_Encryption(){
    //ctor
}

function<string (string)> RH_Encryption::md5(){

    return [] (string value){
        const char* stringValue = value.c_str();
        MD5_CTX md5;
        MD5_Init(&md5);
        MD5_Update(&md5,(const unsigned char*)stringValue, value.length());
        unsigned char buffer[16];
        MD5_Final(buffer, &md5);
        char mdString[32];
        string result;

        for (uint16_t i = 0; i < 16; i++) {
            sprintf(mdString, "%02x", buffer[i]);
            result.append(mdString);
        }
        return result;
    };
}

function<string (string)> RH_Encryption::sha1(){
    return [](string value){
        return value;
    };
}

function<string (string)> RH_Encryption::sha224(){
    return [](string value){
        return value;
    };
}

function<string (string)> RH_Encryption::sha384(){
    return [](string value){
        return value;
    };
}

function<string (string)> RH_Encryption::sha256(){
    return [](string value){
        return value;
    };
}

function<string (string)> RH_Encryption::sha512( ){
    return [](string value){
        return value;
    };
}

function<string (string)> RH_Encryption::none(){
    return [](string value){
        return value;
    };
}

/*function<string (string)> RH_Encryption::hashForLambda(function<string(string)> functionLambda, string value){
    return functionLambda(value);
}*/



RH_Encryption::~RH_Encryption(){
    //dtor
}
